---
sidebar_position: 11
---

# P1711 - Syntax Error

## Error

```erlang
foo() -> XX 3.
    %%      ^ error: Syntax Error
```

## Explanation

This is probably the most common error you will see, as it is generated while you are
typing and the code has a syntax error in it.

This means that the initial analysis of the code cannot make sense of it, because the code is in some way malformed, and does not conform to Erlang syntax.

For details of Erlang and its syntax, see the [reference manual](https://www.erlang.org/doc/reference_manual).
